# Internal

flux config for internal k8s clusters

There are two major paths in this file:
* what this repo does
* [how to test it locally](#how-to-test-this-locally)

## Further reading

 - [fluxcd](https://fluxcd.io/docs/) -- all about flux
   - [flux components](https://fluxcd.io/docs/components/) -- documentation on the components of flux
   - [flux faqs](https://fluxcd.io/docs/faq/) -- some great information on what flux can do and how.
 - [kustomize](https://kustomize.io/) -- heavily utilized in the directory structure

## Repository Structure

There are three directories that are considered 'deployable'. These three repos control the bulk of what can get 
created in the cluster and are defined as flux kustomization objects (using the `kustomize.toolkit.fluxcd.io/v1beta2` 
api) They are in order of dependence:

 - `init`
 - `infrastructure`
 - `apps`

```mermaid
graph LR
  infrastructure --> init 
  apps --> init 
  apps --> infrastructure 
```


Beyond that, there are the following:
 - `charts` (contains `HelmRepository` objects, despite its name)
 - `clusters/*/flux-system/*.yaml` installs the FluxCD kubernetes objects and starts watching a git repo and a path in the repo
 - `clusters/*/*.yaml` instantiates the FluxCD `Kustomization` objects and any supporting kubernetes objects
 - `scripts` (just for GLCI)

### Kustomization objects

These are defined in the `clusters/[cluster_name]/` directory. In each directory, there is a `base` sub-directory and a 
subdirectory for each cluster for cluster-specific flux kustomization objects. These will need to be created for each
new cluster.

There may also be a `values` subdirectory under the cluster directory that specifies patches that should be applied and 
are specific to that cluster.

#### init

Required to be initialize the cluster. Currently, this is only external secrets. It sits alone as the first thing to be 
deployed since each of the other kustomization objects rely on it.

#### infrastructure

Contains resources that are considered `infrastructure`, but rely on the previous `init` resources. These should only 
be resources that manipulate or interact with the cluster and it's resources directly. It should probably go here if 
there is something in `apps` that depends on it.

**THIS WILL INCLUDE ANY CRDs**

#### apps

This is part of the flux kustomization object and contains definitions for 'apps' to be run in the cluster.

If you are planning on using items that reference a CRD, ensure it is included in the `infrastructure` "layer"
since Flux has `dependsOn:` ordering that will ensure it is applied first

Be aware that merely checking `kubctl kustomize` is insufficient, since flux does its own `--dry-run` business
and will cheerfully blow up references that would otherwise `kubectl apply -k` just fine

---

### charts

This directory contains the definitions for all the helm repositories needed to for any helm resources in the cluster
managed by flux.

### clusters

This contains the bootstrapping information for each cluster.

#### gotk-components.yaml

Contains all the flux CRDs, and non-CRD dependent flux resources (namespaces, clusterroles, etc.). This file was 
autogenerated by the flux command line tool and the following command:

```shell
flux install --export > gotk-components.yaml
```

#### git-repository.yaml and git-path.yaml

The `git-repository.yaml` is where one specifies the repo and its branch name to watch for updates

IF YOU ARE CHECKING AN MR, **ensure you do not apply this blindly** as it will by default track `main`

A sibling file, `git-path.yaml`, binds that `GitRepository` to any path in the repo for this cluster

Since the path points at `clusters/${your_cluster}/flux-system`, it should allow flux to upgrade itself

#### cluster-config.yaml

THIS IS NOT A FILE, but rather is a required `ConfigMap` with values specific to each cluster.
These values are pulled in as variables and substituted via the flux kustomization controller.

They come from `resource "kubernetes_config_map" "whatever_cluster_config" {` 
declarations in the `o/i/t/infastructure/*/*.tf`, so adding new keys will be a multi-MR process

They also strip newlines from the `ConfigMap` and `Secret` values, before running [`drone/envsubst`](https://pkg.go.dev/github.com/drone/envsubst/v2#readme-supported-functions) on it. The tl;dr is it works like bash:
- `${normal}`  yes, **always** with the braces
- `${MISSING:-some default}`

Be aware that [one can disable substitution](https://github.com/fluxcd/pkg/blob/kustomize/v0.8.0/kustomize/kustomize_varsub.go#L51-L52)
on a per-resource basis

But if you're trying to do something "cute," best to grab yourself a copy and be sure

```sh
# yes, @latest because there are no tagged releases
go install github.com/drone/envsubst/v2/cmd/envsubst@latest
echo 'Hello ${noun^}' | env noun=world $GOPATH/bin/envsubst
```

#### kustomization.yaml

A [kustomization](https://kustomize.io/) object that pulls resources into the flux kustomization object.

### scripts

#### validate.sh

A validation script suitable for use in a pipeline. Currently has the following requirements
(although you may be happier just pulling the `image:` used by `.gitlab-ci.yml`):
 - yq v4.6
 - kustomize v4.1
 - kubeconform v0.4.12
 - github.com/drone/envsubst/cmd/envsubst


---

## Slack Notifications and Alerts

Alerts are stored in `/infrastructure/[cluster_name]/slack-notifications` and 
`/apps/[cluster_name]/slack-notifications`. The path in `infrastructure` sets up the slack provider for flux, and 
contains alerts for flux itself and a catch-all for kustomizations as well as HelmReleases deployed under 
infrastructure. The path in `apps` contains alerts for HelmReleases under apps.

## Bootstrapping a new cluster

_Be aware this section is not for you if you want to just test your changes locally_

Create new directories (use existing directories as a template) named after your cluster in the following directories:
 - clusters
 - init
 - infrastructure
 - apps

Make sure that `clusters/[cluster_name]/flux-system/gotk-sync.yaml` points to the right path for this cluster if you 
copied/pasted.

Make sure that in `(init|infrastructure|apps)/[cluster_name]/kustomization.yaml` has the correct resources listed for
the cluster.

Make sure that if there is a `(init|infrastructure|apps)/[cluster_name]/values/` directory, that it has the correct
cluster-specific values files, and that they are referenced in kustomization.yaml (from the parent directory to 
`values`) under `.patchesStrategicMerge`.

Once all of your files are properly set, you can bootstrap flux into the cluster by running the following

**AGAIN**, if you are testing an MR, ensure you do not apply that final `flux-system` directory
without modifying the branch it tracks first

```shell
export cluster_name=name-of-cluster
kubectl apply -f clusters/${cluster_name}/flux-system/gotk-components.yaml \
  && kubectl -n flux-system wait --for condition=established --timeout=60s crd --all \
  && kubectl apply --kustomize clusters/${cluster_name}/flux-system --wait=true 
```

## Bootstrapping teleport RDS access

There should be two objects that help with the following:
 - a `ConfigMap` in the `flux-system` namespace named `cluster-config` that contains `rds_endpoint`.
 - a `ExternalSecret` created in the `flux-system` namespace named `rds` that contains the `RDS_USERNAME` and `RDS_PASSWORD`.

1. Pull up the information you need from the two above resources

2. Spin up a new psql pod and attach to it
   ```shell
    kubectl run --image=postgres:12 tmp -- sleep 86400
    kubectl exec -it tmp -- bash -il
   ```
3. Connect to the database
   ```shell
     psql -U [rds_username] -h [rds_endpoint] -p 5432 -W -d orvn
   ```

4. After entering the password, run the following sql to create users for teleport

   This was adapted from [database-schema](https://gitlab.com/openraven/open/database-schema/-/blob/main/deploy/PROD-427.sql)

   ```sql
    -- noinspection SqlNoDataSourceInspectionForFile
    BEGIN;

    CREATE USER orvn_ro IN ROLE rds_iam;
    CREATE USER orvn_superuser IN ROLE rds_iam, rds_superuser;

    COMMIT;
   ```

5. Test teleport access in a different terminal
   ```shell
    tsh db connect --db-user=orvn_superuser --db-name=orvn [cluster_name]
   ```

6. If all checks out, delete the pod
   ```shell
    kubectl delete po tmp
   ```

## Removing resource stuck in terminating state

You have two paths forward:
- `kubectl edit -n ${the_ns} ${kind}/${name}` and replace any `finalizers:` lists with `finalizers: []`
- if that doesn't work for you, then do this `kubectl proxy` dance

As an example, this is how to delete a namespace that it stuck in the terminating state.

1. Pull down the json for the resource
   ```shell
   kubectl get ns flux-system -o json > tmp.json
   ```

2. Edit `tmp.json` to remove the definition for the finalizer.
3. Start a proxy to the API server in the background (or another terminal)
   ```shell
   kubectl proxy &
   ```

4. Use `curl` to apply the updated json back to the cluster directly through the API
    ```shell
    curl -fk -H "Content-Type: application/json" -X PUT --data-binary @tmp.json \
     http://127.0.0.1:8001/api/v1/namespaces/flux-system/finalize
    ```

## Removing flux from a cluster

I guess if you want to do this. It will remove flux components, its custom resources and namespace, and all components 
installed with flux leaving nothing installed through flux still in the cluster.

THIS WILL DELETE THE `flux-system` NAMESPACE
```shell
flux uninstall
```

## How To Test This Locally

Because so much of this is "GitOps" but the `GitRepository` does not honor
the same `Kustomization` envsubst as the rest of Flux,
then we need to craft a `kustomization.yaml` that mimics the gitops part

1. examine `clusters/${target}/*.yaml` to decide which of those are relevant to your change

   most likely, it will just be the apps.yaml one, and within that even more likely localized to `./apps/${c}/kustomization.yaml`
2. Decide which parts of `kustomization.yaml` are relevant to your change
3. Create a `kustomization.yaml` that includes the resources you want to test
4. `kubectl kustomize .` to template things out and see what _will_ be applied
5. `kubectl apply -k .` to do it (or, feel free to just redirect that `kustomize .` output to a file and `apply` it)
